#include "fs.h"
unsigned char fs_buffer[512];
unsigned long akt_sector;
unsigned char init_fs()
{
	if(mmc_init() != 0)
	{
		return 1;
	}
	//MMC_IO_Init();
	mmc_read_sector(1,fs_buffer); //im 1.Sektor steht die aktuelle Sektorposition in den ersten 5byte
	//unsigned char sector_number[5] = {fs_buffer[0],fs_buffer[1],fs_buffer[2],fs_buffer[3],fs_buffer[4]}; //die 5Byte mit Sektorposition zwischenspeichern
	//akt_sector = (unsigned)atol((char*)fs_buffer); //umwandeln der Position von char[5] zu long
	akt_sector = (fs_buffer[0]|(fs_buffer[1]<<8));
	if(akt_sector < 2)
	{
		akt_sector = 2; //sektorposition muss mindestens 2 sein da 0 der MBR und 1 die FS infos beeinhaltet
		//unsigned char sector_number[512];
		//ltoa(akt_sector,(char*)sector_number,10);
		fs_buffer[0] = akt_sector;
		fs_buffer[1] = (akt_sector>>8);
		if(mmc_write_sector(1,fs_buffer)!=0)return 2;
		//if(MMCWriteSector(1,fs_buffer)!=0)return 2;
	}
	mmc_read_sector(akt_sector,fs_buffer); //aktuellen Sektor in Schreibbuffer einlesen
	//MMCReadSector(akt_sector,fs_buffer); //aktuellen Sektor in Schreibbuffer einlesen
	//while(check_sector() != 0)
	//{
	//	akt_sector++;
	//	if(akt_sector > MAX_SEKTOR) return 2;
	//	mmc_read_sector(akt_sector,fs_buffer);
	//}
	if(akt_sector > MAX_SEKTOR) return 2; //MAX_SEKTOR enthlt die hchste Sektornummer der Karte
	return 0;
}
unsigned char sync_fs()
{
	mmc_write_sector(akt_sector,fs_buffer);
	//MMCWriteSector(akt_sector,fs_buffer);
	akt_sector++;
	mmc_read_sector(akt_sector,fs_buffer);
	//MMCReadSector(akt_sector,fs_buffer);
	//while(check_sector() != 0)
	//{
	//	akt_sector++;
	//	if(akt_sector > MAX_SEKTOR) return 1;
	//	mmc_read_sector(akt_sector,fs_buffer);
	//}
	unsigned char sector_number[512];
	//ltoa(akt_sector,(char*)sector_number,10);
	sector_number[0] = akt_sector;
	sector_number[1] = (akt_sector>>8);
	if(mmc_write_sector(1,sector_number)!=0)return 1;
	//if(MMCWriteSector(1,sector_number)!=0)return 1;
	return 0;
}
unsigned char check_sector()
{
	for(uint16_t n = 0;n < 512;n++)
	{
		if(fs_buffer[n] != 0x00) return 1;
	}
	return 0;
}
unsigned char write_data(unsigned char data[15])
{
	uint8_t sektpos = 0;
	for(uint8_t i = 1;i < 32;i++)
	{
		if(fs_buffer[((i*16)-1)] != '\n')
		{
			sektpos = (i-1);
			break;
		}
	}
	if(fs_buffer[511] != '\n')
	{
		for(uint8_t n = 0;n <15;n++)
		{
			fs_buffer[((sektpos*16)+n)] = data[n];
		}
		fs_buffer[((sektpos*16)+15)] = '\n';
	}
	//else
	//{
	//	if(sync_fs() != 0) return 1;
	//	write_data(data);
	//}
	
	return 0;
}
